
package de.ivu.elect.presentation.gebietsbaum.exchange;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.exchange.control.AbstractImporter;
import de.ivu.elect.business.gebietsbaum.boundary.GebietGeometrieImporter;
import de.ivu.elect.business.gebietsbaum.entity.GebietGeometrieImportContext;
import de.ivu.elect.business.gebietsbaum.entity.GebietPolygonPoint;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.exchange.AbstractImportBestaetigenView;
import de.ivu.elect.presentation.exchange.ImportDescription;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;

@Named(GebietGeometrieImportBestaetigenView.COMPONENT_NAME)
@View(viewId = GebietGeometrieImportBestaetigenView.VIEW_ID, useCase = UseCasePermission.GEBIET_GEOMETRIE_IMPORTIEREN)
@OnlineHilfeId(value = "730", mehrfachVergebenOk = true)
public class GebietGeometrieImportBestaetigenView
    extends
      AbstractImportBestaetigenView<List<GebietPolygonPoint>, GebietGeometrieImportContext> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gebietGeometrieImportBestaetigenView";

  public static final String VIEW_ID = "/gebietsbaum/gebiet-geometrie-import-bestaetigen.xhtml";

  @Inject
  private transient GebietGeometrieImporter importer;

  @Inject
  private transient GebietGeometrieImportDescription importDescription;

  private GebietGeometrieImportContext gebietGeometrieImportContext;

  @PostConstruct
  public void init() {
    gebietGeometrieImportContext = new GebietGeometrieImportContext(getSelectedWahltermin(), getSelectedWahl());
  }

  public GebietGeometrieImportBestaetigenView() {
    super();
  }

  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    init();
  }

  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    init();
  }


  @Override
  protected AbstractImporter<List<GebietPolygonPoint>, GebietGeometrieImportContext, ? > getImporter() {
    return importer;
  }

  @Override
  protected GebietGeometrieImportContext getContext() {
    return gebietGeometrieImportContext;
  }

  @Override
  protected ImportDescription getImportDescription() {
    return importDescription;
  }
}
